# Class: SearchClient

## SearchClient

## Constructor

#### new SearchClient(jiraClient)

Used to access Jira REST endpoints in '/rest/api/2/search'

##### Parameters:

Name | Type | Description
--- | --- | ---
`jiraClient` | JiraClient |

Source:
  - api/search.js, line 5

### Methods

#### search(opts, callback)

Searches for issues using JQL.

Sorting the jql parameter is a full JQL expression, and includes an ORDER BY clause.

The fields param (which can be specified multiple times) gives a comma-separated list of fields to include in the response. This can be used to retrieve a subset of fields. A particular field can be excluded by prefixing it with a minus.

By default, only navigable (navigable) fields are returned in this search resource. Note: the default is different in the get-issue resource -- the default there all fields (all).

- *all - include all fields
- navigable - include just navigable fields
- summary,comment - include just the summary and comments
- -description - include navigable fields except the description (the default is *navigable for search)
- *all,-comment - include everything except comments

Expanding Issues in the Search Result: It is possible to expand the issues returned by directly specifying the expansion on the expand parameter passed in to this resources.

For instance, to expand the "changelog" for all the issues on the search result, it is neccesary to specify "changelog" as one of the values to expand.

##### Parameters:

Name | Type | Description
--- | --- | ---

`opts`

The options for the search.

###### Properties

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`jql` | string |  |  | The JQL query string
`startAt` | number | <optional> |  | The index of the first issue to return (0-based)
`maxResults` | number | <optional> |  | The maximum number of issues to return (defaults to 50). The maximum allowable value is dictated by the JIRA property 'jira.search.views.default.max'. If you specify a value that is higher than this number, your search results will be truncated.
`validateQuery` | boolean | <optional> | true | Whether to validate the JQL query
`fields` | array | <optional> |  | The list of fields to return for each issue. By default, all navigable fields are returned.
`expand` | array | <optional> |  | A list of the parameters to expand.

`callback` |  | Called with the search results.

Source:
  - api/search.js, line 14